; Create replacements of the Fx system sprites	 V1.00	2003 Marcel Kilgus
;
; File can be freely copied and used as long as proper credit is given.

	section code

	xref	gu_achpp

	include 'dev8_keys_con'
	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qdos_pt'
	include 'dev8_keys_sysspr'
	include 'dev8_keys_sys'
	include 'dev8_mac_config'

xmax	equ	12
ymax	equ	7
bpp	equ	2
mask	equ	(xmax*bpp+4)*ymax

start
	lea	colour,a0
	move.w	(a0),d7 	; Colour

	moveq	#sms.info,d0
	trap	#1
	move.l	sys_clnk(a0),a3

	move.l	#24*(pto.hdrl+(xmax*bpp+4)*ymax*2),d0
	jsr	gu_achpp
	move.l	a0,a2

	lea	sprites(pc),a0
	moveq	#sp.f1,d1	; Sprite number
loop
	move.l	a0,a1
	move.w	(a0)+,d0
	cmp.w	#-1,d0
	beq.s	end

	add.w	d0,a1
	move.l	a2,-(sp)
	bsr.s	generate_sprite
	move.l	(sp)+,a1
	move.l	pt_vecs(a3),a4
	jsr	pv_sspr(a4)

	addq.w	#1,d1		; Next sprite
	bra.s	loop
end
	moveq	#0,d0
	rts


;+++
; d7 p	Colour of "on" pixel
; a1 u	Pointer to internal sprite definition
; a2 u	Where to put new sprite
;--
generate_sprite
	movem.l d0/d5-d6/a3,-(sp)
	move.w	#$0220,(a2)+	; Colour mode
	move.w	#$0000,(a2)+	; Options etc.
	move.l	(a1)+,(a2)+	; Size
	move.l	#0,(a2)+	; Origin
	move.l	#12,(a2)+	; Relative position of pattern
	move.l	#mask+8,(a2)+	; Relative position of mask
	move.l	#0,(a2)+	; No next sprite

	move.w	-4(a1),d5	; X size
	mulu	#bpp,d5 	; In bytes
	addq.w	#3,d5		; Pad to long word
	andi.w	#$FFFC,d5
	move.w	-2(a1),d6	; Y size
gs_yloop
	move.w	(a1)+,d0	; Pixel word
	move.w	d5,-(sp)
gs_xloop
	lsl.w	#1,d0		; Pixel set?
	bcc.s	gs_nopix
	move.w	#$ffff,mask(a2) ; Yes, set it
	move.w	d7,(a2)+
	bra.s	gs_x
gs_nopix
	clr.w	mask(a2)	; No, don't set it
	clr.w	(a2)+
gs_x
	subq.w	#2,d5
	bne.s	gs_xloop
	move.w	(sp)+,d5
	subq.w	#1,d6
	bne.s	gs_yloop
	adda.w	#mask,a2
	movem.l (sp)+,d0/d5-d6/a3
	rts

sprites
	dc.w	sp_f1-*
	dc.w	sp_f2-*
	dc.w	sp_f3-*
	dc.w	sp_f4-*
	dc.w	sp_f5-*
	dc.w	sp_f6-*
	dc.w	sp_f7-*
	dc.w	sp_f8-*
	dc.w	sp_f9-*
	dc.w	sp_f10-*
	dc.w	sp_f11-*
	dc.w	sp_f12-*
	dc.w	sp_cf1-*
	dc.w	sp_cf2-*
	dc.w	sp_cf3-*
	dc.w	sp_cf4-*
	dc.w	sp_cf5-*
	dc.w	sp_cf6-*
	dc.w	sp_cf7-*
	dc.w	sp_cf8-*
	dc.w	sp_cf9-*
	dc.w	sp_cf10-*
	dc.w	sp_cf11-*
	dc.w	sp_cf12-*
	dc.w	-1

sp_f1
	dc.w	6,7
	dc.w	$E400
	dc.w	$8C00
	dc.w	$8400
	dc.w	$C400
	dc.w	$8400
	dc.w	$8400
	dc.w	$8400

sp_f2
	dc.w	7,7
	dc.w	$EC00
	dc.w	$9200
	dc.w	$8200
	dc.w	$C400
	dc.w	$8800
	dc.w	$9000
	dc.w	$9E00

sp_f3
	dc.w	7,7
	dc.w	$EC00
	dc.w	$9200
	dc.w	$8200
	dc.w	$CC00
	dc.w	$8200
	dc.w	$9200
	dc.w	$8C00

sp_f4
	dc.w	8,7
	dc.w	$E800
	dc.w	$8A00
	dc.w	$8A00
	dc.w	$CF00
	dc.w	$8200
	dc.w	$8200
	dc.w	$8200

sp_f5
	dc.w	8,7
	dc.w	$EF00
	dc.w	$8800
	dc.w	$8E00
	dc.w	$C100
	dc.w	$8100
	dc.w	$8900
	dc.w	$8600

sp_f6
	dc.w	8,7
	dc.w	$E600
	dc.w	$8900
	dc.w	$8800
	dc.w	$CE00
	dc.w	$8900
	dc.w	$8900
	dc.w	$8600

sp_f7
	dc.w	8,7
	dc.w	$EF00
	dc.w	$8900
	dc.w	$8100
	dc.w	$C200
	dc.w	$8200
	dc.w	$8400
	dc.w	$8400

sp_f8
	dc.w	8,7
	dc.w	$E600
	dc.w	$8900
	dc.w	$8900
	dc.w	$C600
	dc.w	$8900
	dc.w	$8900
	dc.w	$8600

sp_f9
	dc.w	8,7
	dc.w	$E600
	dc.w	$8900
	dc.w	$8900
	dc.w	$C700
	dc.w	$8100
	dc.w	$8900
	dc.w	$8600

sp_f10
	dc.w	10,7
	dc.w	$E480
	dc.w	$8D40
	dc.w	$8540
	dc.w	$C540
	dc.w	$8540
	dc.w	$8540
	dc.w	$8480
sp_f11
	dc.w	8,7
	dc.w	$E900
	dc.w	$9B00
	dc.w	$8900
	dc.w	$C900
	dc.w	$8900
	dc.w	$8900
	dc.w	$8900

sp_f12
	dc.w	10,7
	dc.w	$E980
	dc.w	$9A40
	dc.w	$8840
	dc.w	$C880
	dc.w	$8900
	dc.w	$8A00
	dc.w	$8BC0

sp_cf1
	dc.w	11,7
	dc.w	$6E40
	dc.w	$88C0
	dc.w	$8840
	dc.w	$8C40
	dc.w	$8840
	dc.w	$8840
	dc.w	$68E0

sp_cf2
	dc.w	12,7
	dc.w	$6E60
	dc.w	$8890
	dc.w	$8810
	dc.w	$8C20
	dc.w	$8840
	dc.w	$8880
	dc.w	$68F0

sp_cf3
	dc.w	11,7
	dc.w	$6ec0
	dc.w	$8920
	dc.w	$8820
	dc.w	$8cc0
	dc.w	$8820
	dc.w	$8920
	dc.w	$68c0

sp_cf4
	dc.w	11,7
	dc.w	$6e40
	dc.w	$88c0
	dc.w	$8940
	dc.w	$8d40
	dc.w	$8be0
	dc.w	$8840
	dc.w	$6840

sp_cf5
	dc.w	12,7
	dc.w	$6EF0
	dc.w	$8880
	dc.w	$88E0
	dc.w	$8C10
	dc.w	$8810
	dc.w	$8890
	dc.w	$6860

sp_cf6
	dc.w	12,7
	dc.w	$6E60
	dc.w	$8890
	dc.w	$8880
	dc.w	$8CE0
	dc.w	$8890
	dc.w	$8890
	dc.w	$6860

sp_cf7
	dc.w	12,7
	dc.w	$6EF0
	dc.w	$8890
	dc.w	$8810
	dc.w	$8C20
	dc.w	$8820
	dc.w	$8840
	dc.w	$6840

sp_cf8
	dc.w	12,7
	dc.w	$6E60
	dc.w	$8890
	dc.w	$8890
	dc.w	$8C60
	dc.w	$8890
	dc.w	$8890
	dc.w	$6860

sp_cf9
	dc.w	12,7
	dc.w	$6E60
	dc.w	$8890
	dc.w	$8890
	dc.w	$8C70
	dc.w	$8810
	dc.w	$8890
	dc.w	$6860

sp_cf10
	dc.w	13,7
	dc.w	$6E90
	dc.w	$89A8
	dc.w	$88A8
	dc.w	$8CA8
	dc.w	$88A8
	dc.w	$88A8
	dc.w	$69D0

sp_cf11
	dc.w	12,7
	dc.w	$6E90
	dc.w	$89B0
	dc.w	$8890
	dc.w	$8C90
	dc.w	$8890
	dc.w	$8890
	dc.w	$6890

sp_cf12
	dc.w	14,7
	dc.w	$6E98
	dc.w	$89A4
	dc.w	$8884
	dc.w	$8C88
	dc.w	$8890
	dc.w	$88A0
	dc.w	$68BC

colour	dc.w	$00f8

	mkcfhead {SystemSprites},{1.00}
	mkcfitem word,0,colour,,,\
       {Colour for sprites},0,65535
	mkcfend

	end
