; Replacement system sprites	V1.00			2003 Marcel Kilgus
;
; File can be freely copied and used as long as proper credit is given.

	section code

	include 'dev8_keys_con'
	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qdos_pt'
	include 'dev8_keys_sysspr'
	include 'dev8_keys_sys'
	include 'dev8_mac_config'

start
	moveq	#sms.info,d0
	trap	#1
	move.l	sys_clnk(a0),a3
	move.l	pt_vecs(a3),a4

	lea	sprite_table,a5
	bra.s	next_sprite
loop
	move.w	(a5)+,d0
	adda.w	d0,a1
	jsr	pv_sspr(a4)

next_sprite
	move.l	a5,a1
	move.w	(a5)+,d1
	cmp.w	#-1,d1
	bne.s	loop

	moveq	#0,d0
	rts

sprite_table
	dc.w	sp.arrow,sp_arrow-*
	dc.w	sp.lock,sp_lock-*
	dc.w	sp.null,sp_null-*
	dc.w	sp.key,sp_key-*
	dc.w	sp.busy,sp_busy-*
	dc.w	sp.wmovep,sp_wmovep-*
	dc.w	sp.wsizep,sp_wsizep-*
	dc.w	sp.wmove,sp_wmove-*
	dc.w	sp.wsize,sp_wsize-*
	dc.w	sp.sleep,sp_sleep-*
	dc.w	sp.wake,sp_wake-*
	dc.w	sp.cursor,sp_cursor-*
	dc.w	sp.curflash,sp_curflash-*
	dc.w	-1

sp_arrow
	incbin	'win1_src_sysspr_arrow-trns_spr'
sp_lock
	incbin	'win1_src_sysspr_lock_spr'
sp_null
	incbin	'win1_src_sysspr_empty_spr'
sp_key
	incbin	'win1_src_sysspr_wait_spr'
sp_busy
	incbin	'win1_src_sysspr_busy_spr'
sp_wmovep
	incbin	'win1_src_sysspr_wmovep_spr'
sp_wsizep
	incbin	'win1_src_sysspr_wsizep_spr'

sp_wmove
	dc.w	$0220,$0004
	dc.w	14,10,7,4
	dc.l	swm_patt-*
	dc.l	swm_mask-*
	dc.l	0,0
	dc.l	swm_ext-*
swm_ext
	dc.l	sp_wmove-*
	dc.l	swm_current-*
	dc.l	swm_current-*
	dc.l	0,0
swm_patt
	dc.w	$4A9C,$2EB5,$2EB5,$2EB5,$2EB5,$2EB5,$0EB5,$2FB5
	dc.w	$2EB5,$0EB5,$0000,$0000,$0000,$0000
	dc.w	$2008,$5BEF,$7CEF,$5BEF,$3AEF,$1AE7,$F9E6,$D8DE
	dc.w	$97DE,$2FB5,$0000,$0000,$0000,$0000
	dc.w	$2008,$5BEF,$3AEF,$F9E6,$D8E6,$B7DE,$76D6,$55D6
	dc.w	$34CE,$2FB5,$0000,$0000,$0000,$0000
	dc.w	$2000,$F9E6,$D8DE,$97DE,$4A9C,$2EB5,$2EB5,$2EB5
	dc.w	$2EB5,$2EB5,$0EB5,$2FB5,$2EB5,$0EB5
	dc.w	$2000,$76D6,$55D6,$34CE,$2008,$5BEF,$7CEF,$5BEF
	dc.w	$3AEF,$1AE7,$F9E6,$D8DE,$97DE,$2FB5
	dc.w	$2008,$14CE,$D3C5,$B2C5,$2008,$5BEF,$3AEF,$F9E6
	dc.w	$D8E6,$B7DE,$76D6,$55D6,$34CE,$2FB5
	dc.w	$2008,$2000,$2000,$2000,$2000,$F9E6,$D8DE,$97DE
	dc.w	$76D6,$35D6,$14CE,$F3C5,$B2C5,$0EB5
	dc.w	$0000,$0000,$0000,$0000,$2000,$76D6,$55D6,$34CE
	dc.w	$F3CD,$D2C5,$B1C5,$91BD,$70BD,$0EB5
	dc.w	$0000,$0000,$0000,$0000,$2008,$14CE,$D3C5,$B2C5
	dc.w	$91BD,$70BD,$50BD,$4FBD,$4FBD,$0EB5
	dc.w	$0000,$0000,$0000,$0000,$2008,$2000,$2000,$2000
	dc.w	$2000,$8439,$2000,$2000,$2000,$4A9C


x	equ	-1

swm_mask
	dc.w	x,x,x,x,x,x,x,x,x,x,0,0,0,0
	dc.w	x,x,x,x,x,x,x,x,x,x,0,0,0,0
	dc.w	x,x,x,x,x,x,x,x,x,x,0,0,0,0
	dc.w	x,x,x,x,x,x,x,x,x,x,x,x,x,x
	dc.w	x,x,x,x,x,x,x,x,x,x,x,x,x,x
	dc.w	x,x,x,x,x,x,x,x,x,x,x,x,x,x
	dc.w	x,x,x,x,x,x,x,x,x,x,x,x,x,x
	dc.w	0,0,0,0,x,x,x,x,x,x,x,x,x,x
	dc.w	0,0,0,0,x,x,x,x,x,x,x,x,x,x
	dc.w	0,0,0,0,x,x,x,x,x,x,x,x,x,x

swm_current
	incbin	'win1_src_sysspr_wmove-gold_spr'

sp_wsize
	dc.w	$0220,$00C4
	dc.w	13,9,6,4
	dc.l	s16p_wsize-*
	dc.l	s16m_wsize-*
	dc.l	0,0
	dc.l	sws_ext-*
sws_ext
	dc.l	sp_wsize-*
	dc.l	sws_current-*
	dc.l	sws_current-*
	dc.l	0,0
s16p_wsize
	dc.b	'RLE2'
	dc.l	252
	dc.b	$00,$4A,$9C,$FB,$2E,$B5,$09,$0E,$B5,$2F,$B5,$2E,$B5,$0E,$B5,$2E
	dc.b	$B5,$0E,$B5,$00,$00,$20,$00,$BE,$FF,$BD,$F7,$FF,$BE,$FF,$FF,$BD
	dc.b	$F7,$FF,$9D,$F7,$05,$7C,$F7,$5B,$EF,$3B,$EF,$0E,$B5,$00,$00,$20
	dc.b	$08,$FC,$5C,$EF,$FF,$5B,$EF,$06,$3A,$EF,$1A,$EF,$19,$E7,$F9,$E6
	dc.b	$2F,$B5,$00,$00,$20,$08,$FC,$3B,$EF,$03,$1A,$EF,$60,$31,$40,$52
	dc.b	$C8,$8B,$FF,$4A,$9C,$02,$2F,$B5,$00,$00,$20,$00,$FC,$F9,$E6,$01
	dc.b	$D8,$E6,$60,$31,$FF,$4F,$BD,$04,$50,$BD,$76,$DE,$0E,$B5,$00,$00
	dc.b	$20,$00,$FD,$B8,$DE,$0B,$D8,$E6,$35,$D6,$C0,$41,$4F,$BD,$4A,$9C
	dc.b	$76,$DE,$FF,$FF,$0E,$B5,$00,$00,$20,$00,$76,$D6,$76,$DE,$FF,$76
	dc.b	$D6,$09,$35,$D6,$4F,$B5,$20,$52,$C0,$41,$76,$DE,$3A,$EF,$FF,$FF
	dc.b	$0E,$B5,$00,$00,$20,$08,$FD,$D2,$C5,$03,$4F,$B5,$09,$94,$00,$00
	dc.b	$76,$DE,$FE,$FF,$FF,$02,$0E,$B5,$00,$00,$20,$08,$FD,$20,$00,$01
	dc.b	$84,$39,$43,$29,$FD,$20,$00,$02,$20,$08,$4A,$9C,$00,$00
s16m_wsize
	dc.b	'RLE2'
	dc.l	252
	dc.b	$F4,$FF,$FF,$00,$00,$00,$F4,$FF,$FF,$00,$00,$00,$F4,$FF,$FF,$00
	dc.b	$00,$00,$F4,$FF,$FF,$00,$00,$00,$F4,$FF,$FF,$00,$00,$00,$F4,$FF
	dc.b	$FF,$00,$00,$00,$F4,$FF,$FF,$00,$00,$00,$F4,$FF,$FF,$00,$00,$00
	dc.b	$F4,$FF,$FF,$00,$00,$00

sws_current
	incbin	'win1_src_sysspr_wsize-gold_spr'

sp_wake
	dc.w	$0220,$00C4
	dc.w	9,10,4,5
	dc.l	s16p_wake-*
	dc.l	s16m_wake-*
	dc.l	0,0
	dc.l	sww_ext-*
sww_ext
	dc.l	sp_wake-*
	dc.l	sww_current-*
	dc.l	sww_current-*
	dc.l	0,0
s16p_wake
	dc.b	'RLE2'
	dc.l	200
	dc.b	$FD,$00,$00,$FF,$B2,$94,$01,$20,$14,$B2,$94,$FC,$00,$00,$00,$B2
	dc.b	$94,$FE,$C0,$1E,$FC,$00,$00,$01,$B2,$94,$C0,$1E,$FF,$E0,$15,$00
	dc.b	$20,$14,$FD,$00,$00,$01,$B2,$94,$C0,$1E,$FF,$E0,$15,$00,$20,$14
	dc.b	$FC,$00,$00,$03,$B2,$94,$C0,$1E,$E0,$15,$20,$14,$FB,$00,$00,$03
	dc.b	$B2,$94,$C0,$1E,$E0,$15,$20,$14,$FC,$00,$00,$01,$B2,$94,$C0,$1E
	dc.b	$FE,$E0,$15,$00,$20,$14,$FC,$00,$00,$03,$B2,$94,$C0,$1E,$E0,$15
	dc.b	$20,$14,$FA,$00,$00,$01,$B2,$94,$C0,$1E,$F1,$00,$00,$00
s16m_wake
	dc.b	'RLE2'
	dc.l	200
	dc.b	$FD,$00,$00,$FD,$FF,$FF,$FC,$00,$00,$FC,$FF,$FF,$FD,$00,$00,$FB
	dc.b	$FF,$FF,$FE,$00,$00,$FA,$FF,$FF,$FE,$00,$00,$FC,$FF,$FF,$FC,$00
	dc.b	$00,$FC,$FF,$FF,$FD,$00,$00,$FA,$FF,$FF,$FD,$00,$00,$FC,$FF,$FF
	dc.b	$FB,$00,$00,$FE,$FF,$FF,$F9,$00,$00,$00,$FF,$FF,$FB,$00,$00,$00

sww_current
	incbin	'win1_src_sysspr_wake-gold_spr'

sp_sleep
	dc.w	$0220,$00C4
	dc.w	12,10,6,5
	dc.l	s16p_sleep-*
	dc.l	s16m_sleep-*
	dc.l	0,0
	dc.l	swl_ext-*
swl_ext
	dc.l	sp_sleep-*
	dc.l	swl_current-*
	dc.l	swl_current-*
	dc.l	0,0
s16p_sleep
	dc.b	'RLE2'
	dc.l	240
	dc.b	$FF,$00,$00,$F9,$AC,$21,$FD,$00,$00,$00,$AC,$21,$FC,$BF,$EF,$00
	dc.b	$94,$5B,$FC,$00,$00,$02,$AC,$21,$BF,$EF,$1F,$CF,$FF,$3F,$AE,$01
	dc.b	$9C,$7C,$94,$5B,$FE,$00,$00,$FE,$AC,$21,$01,$BF,$EF,$1F,$CF,$FF
	dc.b	$3F,$AE,$01,$9C,$7C,$94,$5B,$FE,$00,$00,$00,$02,$00,$FF,$BF,$EF
	dc.b	$FF,$1F,$CF,$FF,$3F,$AE,$FE,$9C,$7C,$00,$94,$5B,$FF,$00,$00,$01
	dc.b	$02,$00,$9C,$7C,$FC,$3F,$AE,$01,$9C,$7C,$94,$5B,$FD,$00,$00,$01
	dc.b	$02,$00,$9C,$7C,$FE,$3F,$AE,$01,$9C,$7C,$94,$5B,$FB,$00,$00,$04
	dc.b	$02,$00,$9C,$7C,$3F,$AE,$9C,$7C,$94,$5B,$F9,$00,$00,$02,$02,$00
	dc.b	$9C,$7C,$94,$5B,$F7,$00,$00,$00,$02,$00,$FB,$00,$00,$00
s16m_sleep
	dc.b	'RLE2'
	dc.l	240
	dc.b	$FF,$00,$00,$F9,$FF,$FF,$FD,$00,$00,$F9,$FF,$FF,$FD,$00,$00,$F9
	dc.b	$FF,$FF,$FF,$00,$00,$E9,$FF,$FF,$00,$00,$00,$F7,$FF,$FF,$FE,$00
	dc.b	$00,$F9,$FF,$FF,$FC,$00,$00,$FB,$FF,$FF,$FA,$00,$00,$FD,$FF,$FF
	dc.b	$F8,$00,$00,$FF,$FF,$FF,$FC,$00,$00,$00

swl_current
	incbin	'win1_src_sysspr_sleep-gold_spr'

sp_cursor
	dc.w	$0220,$00A0
	dc.w	6,10,3,4
	dc.l	s16p_sprite-*
	dc.l	s16m_sprite-*
	dc.l	0

sp_curflash
	dc.w	$0220,$0AA0
	dc.w	6,10,3,4
	dc.l	s16p_sprite-*
	dc.l	s16m_sprite-*
	dc.l	sp_flash-*
sp_flash
	dc.w	$0100,$1400
	dc.w	6,10,3,4
	dc.l	sp_zero-*
	dc.l	sp_zero-*
	dc.l	0

s16p_sprite
	dc.w	$F0FF,$F0FF,$AFFF,$2DFF,$8AF6,$C7ED
	dc.w	$F0FF,$F0FF,$8EFF,$ECF6,$49F6,$86ED
	dc.w	$F0FF,$F0FF,$6EFF,$CBF6,$08EE,$45ED
	dc.w	$F0FF,$AFFF,$2DFF,$8AF6,$C7ED,$04E5
	dc.w	$F0FF,$8EFF,$ECF6,$49F6,$86ED,$C3E4
	dc.w	$D0FF,$6EFF,$CBF6,$08EE,$45ED,$A2E4
	dc.w	$AFFF,$2DFF,$8AF6,$C7ED,$04E5,$81E4
	dc.w	$8EFF,$ECF6,$49F6,$86ED,$E3E4,$41E4
	dc.w	$6EFF,$ABF6,$08EE,$45ED,$A2E4,$20DC
	dc.w	$2DFF,$8AF6,$C7ED,$04E5,$61E4,$00DC

s16m_sprite
	dc.b	'RLE1'
	dc.l	60
	dc.b	$C5,$CC

sp_zero
	dcb.w	48,0

	end
